// SpeedStepDll.cpp : Defines the entry point for the DLL application.
//
extern "C" {
#include <windows.h>
#include <winnt.h>
#include <powrprof.h>
};

#include "stdafx.h"
#include "SpeedStepDll.h"
#include "..\\..\\inc\\shared.h"
#include "install.h"

//
// Defines
//
#define ALWAYS_ON   0x0

//
// Globals
//
MACHINE_PROCESSOR_POWER_POLICY mppp;

UINT uiDynThrottleAC;
UINT uiDynThrottleDC;

bool bHasBeenDisabledFirst = FALSE;
bool bStopEvent = false;
bool bDriverEnabled = false;

static HANDLE	h_DeviceDriver;
HANDLE			SharedEvent;


////////////////////////////////////////////////////////////////////////

/*
struct _THREADPARMS {
	double* pdBestRadius;
	int* piBestIndex;
	int iStart;
	int iMax;
	int cxClient;
	int cyClient;
} ThreadParms, *pThreadParms;
*/

DWORD WINAPI SetupDriverEvent(LPVOID sParms) //bool SetupDriverEvent()
{
	DWORD		bytesReturned;
	DWORD		WaitStatus;
	UINT		psIdx = 0;
	bool		bRet = 0;

	//
	// Create named event that will be shared between the driver and
	// application. Note that this event is actually created under 
	// \BaseNamedObjects\ by the object manager so we will need to add 
	// that to the event name when we try and open this event from kernel mode
	//
	SharedEvent = CreateEvent(NULL, false, false, "SharedEvent");
	if ( SharedEvent == NULL ) 
    {
		return 0;
	}

	//
	// Send an IOCTL to the driver to signal that the named event
	// has been created and that it can now open a handle to it
	//
	if (!DeviceIoControl( h_DeviceDriver, 
						  IOCTL_PWRNTFY_EVENT, 
						  NULL, 0, 
						  NULL, 0, 
				 		  &bytesReturned, 
						  NULL )) 
    {
		return 0;
	}

	if (!DeviceIoControl( h_DeviceDriver, 
						  IOCTL_PWRNTFY_EVENT_START, 
						  NULL, 0, 
						  NULL, 0, 
				 		  &bytesReturned, 
						  NULL )) 
    {
		return 0;
	}

	while ( !bStopEvent )
	{
		WaitStatus = WaitForSingleObject( SharedEvent, INFINITE ); 
		if ( WaitStatus == WAIT_OBJECT_0 ) 
		{
			GetActivePwrScheme(&psIdx); 
			if ( ReadProcessorPwrScheme(psIdx, &mppp) ) 
			{
				uiDynThrottleAC = mppp.ProcessorPolicyAc.DynamicThrottle;
				uiDynThrottleDC = mppp.ProcessorPolicyDc.DynamicThrottle;
			}
    
			mppp.ProcessorPolicyAc.DynamicThrottle = ALWAYS_ON;
			mppp.ProcessorPolicyDc.DynamicThrottle = ALWAYS_ON;
    
			WriteProcessorPwrScheme(psIdx, &mppp); 
			SetActivePwrScheme(psIdx, NULL, NULL); 
		}
	}

	return 1;
}


SPEEDSTEPDLL_API bool ReturnOriginalPowerScheme( void )
{
   	UINT psIdx = 0;
	bool bRet = false;

	bStopEvent = true;

    if ( bHasBeenDisabledFirst == true )
    {
	    if ( GetActivePwrScheme(&psIdx) ) 
        {
		    if ( ReadProcessorPwrScheme(psIdx, &mppp) ) 
            {
			    mppp.ProcessorPolicyAc.DynamicThrottle = uiDynThrottleAC;
			    mppp.ProcessorPolicyDc.DynamicThrottle = uiDynThrottleDC;

	    	    if ( WriteProcessorPwrScheme(psIdx, &mppp) ) 
                {
				    if ( SetActivePwrScheme(psIdx, NULL, NULL) ) 
                    {
					    bRet = true;
				    }
			    }
		    }
	    }
    }
	return bRet;
}


SPEEDSTEPDLL_API bool SetAlwaysOnPowerScheme( void )
{
	UINT psIdx = 0;
	bool bRet = false;

    if ( bHasBeenDisabledFirst == false )
        bHasBeenDisabledFirst = true;

	if ( GetActivePwrScheme(&psIdx) ) 
    {
		if ( ReadProcessorPwrScheme(psIdx, &mppp) ) 
        {
			uiDynThrottleAC = mppp.ProcessorPolicyAc.DynamicThrottle;
			uiDynThrottleDC = mppp.ProcessorPolicyDc.DynamicThrottle;
			bRet = true;
		}
	}
    
    mppp.ProcessorPolicyAc.DynamicThrottle = ALWAYS_ON;
	mppp.ProcessorPolicyDc.DynamicThrottle = ALWAYS_ON;
    
	if (WriteProcessorPwrScheme(psIdx, &mppp)) 
    {
		if (SetActivePwrScheme(psIdx, NULL, NULL)) 
        {
			bRet = true;
		}
	}
    
	
	HANDLE h_SDEThread = CreateThread(NULL, 0, SetupDriverEvent, NULL, 0, NULL);
	//if ( !SetupDriverEvent() ) return false;

	return bRet;
}
 

bool APIENTRY DllMain(
	HANDLE hModule, 
    DWORD  ul_reason_for_call, 
    LPVOID lpReserved
	)
{
    int         i;
	char        szDriverLocation[512];

    switch (ul_reason_for_call)
	{
	case DLL_PROCESS_ATTACH:
		if ( !bDriverEnabled )
		{
			GetWindowsDirectory(szDriverLocation, 512);	 
			strcat(szDriverLocation, "\\system32\\");
			strcat(szDriverLocation, DRIVER_NAME);
			strcat(szDriverLocation, ".sys");

			for (i = 0; i < 100 && !ManageDriver( DRIVER_NAME, szDriverLocation, DRIVER_FUNC_REMOVE ); i++);
			for (i = 0; i < 100 && !ManageDriver( DRIVER_NAME, szDriverLocation, DRIVER_FUNC_INSTALL ); i++);

			h_DeviceDriver = CreateFile( DRIVER_NAME_DYN_LOAD,               
										 GENERIC_READ | GENERIC_WRITE,       
										 0, 
										 NULL,                               
										 OPEN_EXISTING,  
										 FILE_ATTRIBUTE_NORMAL, 
										 NULL );
			if ( h_DeviceDriver == INVALID_HANDLE_VALUE ) 
				bDriverEnabled = false;
			else 
				bDriverEnabled = true;		   // SET BPX DriverDispatchPower in SICE
		}
		return bDriverEnabled;

	case DLL_PROCESS_DETACH:
		if ( bDriverEnabled )
		{
			bStopEvent = true;
		
            GetWindowsDirectory(szDriverLocation, 512);	 // reference the driver in the proper folder
			strcat(szDriverLocation, "\\system32\\");
			strcat(szDriverLocation, DRIVER_NAME);
			strcat(szDriverLocation, ".sys");
 			
			for (i = 0; i < 100 && !ManageDriver( DRIVER_NAME, szDriverLocation, DRIVER_FUNC_REMOVE ); i++);
			//for (i = 0; i < 100 && !ManageDriver( DRIVER_NAME, szDriverLocation, DRIVER_FUNC_REMOVE ); i++);

			CloseHandle( SharedEvent );
			CloseHandle( h_DeviceDriver );

			bDriverEnabled = false;
		}
		return bDriverEnabled;

	case DLL_THREAD_ATTACH:
	case DLL_THREAD_DETACH:
	default:
		return true; 
	}
}




