//
// PwrControlTest.cpp :
// 
//     Simple test applet which disables SpeedStepping then re-enables the 
//     previously defined system power state.
//

#include "stdafx.h"
#include <windows.h>

HINSTANCE hPWRDLL;
typedef bool (CALLBACK* t_fnPWRDLL_CB)(void);

t_fnPWRDLL_CB fnPWRDLL_ESS;
t_fnPWRDLL_CB fnPWRDLL_DSS;

void main( void )
{
	bool blReVal = false;

    hPWRDLL = LoadLibrary("PWRCONTROL");

	if (hPWRDLL != NULL)
	{
		fnPWRDLL_ESS = (t_fnPWRDLL_CB)GetProcAddress( hPWRDLL, "ReturnOriginalPowerScheme" );
		if (!fnPWRDLL_ESS)
		{
			printf("Could not get EnableSpeedStepping Proc Handle\n");
			return;
		}

		fnPWRDLL_DSS = (t_fnPWRDLL_CB)GetProcAddress( hPWRDLL, "SetAlwaysOnPowerScheme" );
		if (!fnPWRDLL_DSS)
		{
			printf("Could not get DisableSpeedStepping Proc Handle\n");
			return;
		}
	}

    if ( !fnPWRDLL_DSS() )
    {
        MessageBox(NULL, "Unable to set Always on Power Scheme", "SpeedStepTest", MB_OK );
        return;
    }

	// Sleep for 20 seconds
    Sleep( 20000 );


    if ( !fnPWRDLL_ESS() )
    {
        MessageBox(NULL, "Unable to return original Power Scheme", "SpeedStepTest", MB_OK );
        return;
    }

   	// Sleep for 20 seconds
    Sleep( 20000 );

	/*
    // Sleep for 20 seconds
    Sleep( 20000 );
 
    if ( !DisableSpeedStepping() )
    {
        MessageBox(NULL, "Unable to disable Speedstepping", "SpeedStepTest", MB_OK );
        return;
    }

    // Sleep for 20 seconds
    Sleep( 20000 );

    if ( !EnableSpeedStepping() )
    {
        MessageBox(NULL, "Unable to reenable Speedstepping", "SpeedStepTest", MB_OK );
    }
	*/

    FreeLibrary( hPWRDLL );

	return;
}

