#ifndef _PWRNTFY_H_
#define _PWRNTFY_H_

typedef unsigned char  BYTE;
typedef BYTE          *PBYTE;
typedef unsigned short WORD;
typedef WORD          *PWORD;
typedef unsigned int   UINT;
typedef unsigned long  DWORD;
typedef DWORD         *PDWORD;
typedef void           *PVOID;
typedef void           *LPVOID;

#include <ntddk.h>
#include "stdio.h"
#include "stdarg.h"
#include "..\\inc\\shared.h"

#define UNI_DEVICE_NAME L"\\Device\\pwrntfy"
#define UNI_DOS_DEVICE_NAME L"\\DosDevices\\pwrntfy"

#define TRUE 1
#define FALSE 0
#define BOOL unsigned short
#define INT3 __asm int 3

typedef struct _DEVICE_EXTENSION_ {
	WORD Removing;

	ULONG HalThunkForKeUpdateSystemTime;
	ULONG HalThunkForKeUpdateRunTime;
	ULONG HalThunkForKeProfileInterrupt;
	ULONG HalThunkForStartProfileInterrupt;
	ULONG HalThunkForStopProfileInterrupt;
} DEVICE_EXTENSION, *PDEVICE_EXTENSION;


BOOL g_bHooksInstalled;
BOOL g_bKernelHooksSupported;
BOOL g_bChangingPoolSize;
static DWORD				POOL_SIZE;			
static PVOID				g_pvPool;
static PMDL					g_pMDL;
static PVOID				g_pvUserPool;
static __int32				g_iFamily;
static OBJECT_ATTRIBUTES	g_oAttributes;
static PCALLBACK_OBJECT		g_pcObject;
static UNICODE_STRING		g_UnicodeString;
static PVOID				g_pvCallbackRegistration;
static KSPIN_LOCK			g_PoolSpinLock;
static KIRQL				g_OldIrql;
static DWORD				g_dwPause;

PDEVICE_EXTENSION g_pde;
 
VOID 
SetupGlobals(
	VOID
	);

VOID
DeviceDispatchPower (
    IN PVOID CallbackContext,
    IN PVOID Argument1,
    IN PVOID Argument2
    );

VOID 
SetupPowerCallback(
	VOID
	);

VOID
RemovePowerCallback(
    VOID
    );

VOID
DriverUnload(
    IN PDRIVER_OBJECT pdrvo
    );

NTSTATUS
DriverCreateClose(
    IN PDEVICE_OBJECT pdevo,
    IN PIRP pirp
    );

NTSTATUS
DriverDeviceControl(
    IN PDEVICE_OBJECT pdevo,
    IN PIRP pirp
    );

#endif